<?php #2020-02-03
require_once(axs_dir('site_base').'articles.base.class.php');
class axs_news extends axs_articles_base {
	//public $name='articles_news';
	public $module='news';
	public $forms=array('news'=>array('label'=>'news'), );
	public $folders=false;
	public $sql_limit=array(25,50,100,250,500,100);
	public $fields_article=array(
		''=>array('dir_entry'=>'{$id}/', 'sql'=>array('table'=>'{$px}{$name}', )),
		'id'=>array('type'=>'number', 'size'=>10, 'required'=>0, 'readonly'=>'readonly', 'thead'=>1, 'search'=>1, 'sql'=>array(
			'_type'=>'int', '_value'=>10, '_attribute'=>'unsigned', 'Key'=>'PRI', 'Extra'=>'AUTO_INCREMENT', 
			), ),
		'title'=>array('type'=>'text', 'size'=>50, 'required'=>1, 'maxlength'=>255, 'thead'=>1, 'search'=>1, ),
		'publ'=>array('type'=>'timestamp', 'size'=>10, 'required'=>1, 'format'=>'d.m.Y H:i', 'thead'=>1, 'search'=>1, 'sort'=>1, 'DESC'=>'DESC', 'value'=>'time()', ),
		'arh'=>array('type'=>'timestamp', 'size'=>10, 'required'=>0, 'format'=>'d.m.Y H:i', 'thead'=>1, 'search'=>1, 'sort'=>1, ),
		'file'=>array('type'=>'file', 'size'=>0, 'required'=>0, 'accept'=>'image.*', 'thead'=>1, 'add_fn'=>true, 'multiple'=>false, 't'=>array(
				't1'=>array('w'=>800, 'h'=>800, 'ext'=>'jpg', 'crop_pos'=>'', 'crop_size'=>'', 'q'=>90, 'name_base'=>'{$id}', 'alt'=>'{$id}.t1.{$ext}', 'dw'=>200, 'dh'=>200, 'link'=>array('c'=>'{$c}', 't'=>'{$title_alias}', 'id'=>'{$id}'), 'link_target'=>'', ),
				't2'=>array('w'=>3000, 'h'=>3000, 'ext'=>'jpg', 'q'=>90, 'name_base'=>'{$id}', 'alt'=>'{$id}.t2.{$ext}', 'dw'=>200, 'dh'=>200, 'link'=>'t2', 'link_target'=>'_blank', ),
				),
			),
		'file_caption'=>array('type'=>'text', 'size'=>50, 'required'=>0, 'maxlength'=>255, 'thead'=>1, 'search'=>1, ),
		'summary'=>array('type'=>'wysiwyg', 'size'=>75, 'required'=>0, 'rows'=>2, 'thead'=>1, ),
		'text'=>array('type'=>'wysiwyg', 'size'=>75, 'required'=>0, ),
		'files'=>array('type'=>'table', 'size'=>1, 'required'=>0, 'thead'=>0, 'add_fn'=>false, 'options'=>array(
				'nr'=>array('type'=>'number', 'required'=>1, 'min'=>0, 'max'=>255, 'size'=>3, 'rank'=>true, 'ASC'=>'ASC', ),
				'file'=>array('type'=>'file', 'size'=>0, 'required'=>0, 'accept'=>'image.*', 'thead'=>1, 'add_fn'=>true, 't'=>array(
						't1'=>array('w'=>600, 'h'=>400, 'ext'=>'jpg', 'crop_pos'=>'', 'crop_size'=>'', 'q'=>90, 'name_base'=>'{$_field}.{$_key}', 'alt'=>'{$_title} {$_key}', 'dw'=>200, 'dh'=>200, /*'link'=>'t2', 'link_target'=>'popup',*/ ),
						't2'=>array('w'=>2000, 'h'=>2000, 'ext'=>'jpg', 'q'=>90, 'name_base'=>'{$_field}.{$_key}', 'alt'=>'{$title} {$_key}', 'dw'=>200, 'dh'=>200, 'link'=>'', 'link_target'=>'', ),
						),
					),
				'_add'=>array('type'=>'submit', ),
				'_del'=>array('type'=>'checkbox', ),
				),
			),
		'seo'=>array('type'=>'fieldset', 'size'=>0, 'required'=>0, ),
		'title_alias'=>array('type'=>'text', 'size'=>50, 'required'=>0, 'maxlength'=>255, ),
		'meta_description'=>array('type'=>'text', 'size'=>50, 'required'=>0, 'maxlength'=>255, ),
		'seo_end'=>array('type'=>'fieldset_end', 'size'=>0, 'required'=>0, ),
		'comments'=>array('type'=>'checkbox', 'size'=>1, 'required'=>0, 'value'=>1, 'thead'=>1, 'search'=>1, ),
		'comments_mail'=>array('type'=>'email', 'size'=>20, 'required'=>0, 'maxlength'=>255, 'multiple'=>'multiple', ),
		'updated'=>array('type'=>'timestamp-updated', 'size'=>50, 'required'=>0, 'thead'=>1, 'search'=>1, 'sort'=>1, 'DESC'=>'DESC', ),
		'save'=>array('type'=>'submit', 'size'=>0, 'required'=>0, 'add_fn'=>true, ),
		);
	static $tr=array(
		'en'=>array(
			'form.title'=>'news',
			'id.lbl'=>'ID',
			'title.lbl'=>'title',
			'publ.lbl'=>'published',
			'arh.lbl'=>'archived',
			'file.lbl'=>'picture',
			'file_caption.lbl'=>'picture caption',
			'summary.lbl'=>'summary',
			'article_content.lbl'=>'article content',
			'text.lbl'=>'text',
			'files.lbl'=>'pictures',
			'files.nr.lbl'=>'nr',
			'files.file.lbl'=>'file',
			'seo.lbl'=>'SEO',
			'title_alias.lbl'=>'URL alias',
			'meta_description.lbl'=>'<meta description>',
			'rank_up.lbl'=>'rank up',
			'rank_down.lbl'=>'rank down',
			'comments.lbl'=>'allow comments',
			'comments_mail.lbl'=>'send comments to e-mail',
			'updated.lbl'=>'updated',
			'save.lbl'=>'save',
			'read_more.lbl'=>'read more',
			'prev.lbl'=>'previous',
			'next.lbl'=>'next',
			'comments.form.title'=>'comments',
			'comments.id.lbl'=>'ID',
			'comments.time.lbl'=>'time',
			'comments.name.lbl'=>'name',
			'comments.message.lbl'=>'comment',
			'comments.captcha.lbl'=>'verification code',
			'comments.post.lbl'=>'post',
			'comments.user_ip.lbl'=>'IP',
			'comments.hostname.lbl'=>'domain',
			'msg'=>'Comment has been saved!',
			'msg_value_required'=>'input required!',
			'msg_value_invalid'=>'invalid input!',
			'msg_value_unique'=>'input value must be unique!',
			'back.lbl'=>'back',
			),
		'et'=>array(
			'form.title'=>'uudised',
			'id.lbl'=>'ID',
			'title.lbl'=>'pealkiri',
			'publ.lbl'=>'avaldatud',
			'arh.lbl'=>'arhiveeritud',
			'file.lbl'=>'pildifail',
			'file_caption.lbl'=>'pildiallkiri',
			'summary.lbl'=>'sissejuhatus',
			'article_content.lbl'=>'artikli sisu',
			'text.lbl'=>'sisutekst',
			'files.lbl'=>'pildid',
			'files.nr.lbl'=>'nr',
			'files.file.lbl'=>'fail',
			'seo.lbl'=>'SEO',
			'title_alias.lbl'=>'URL alias',
			'meta_description.lbl'=>'<meta description>',
			'rank_up.lbl'=>'liiguta üles',
			'rank_down.lbl'=>'liiguta alla',
			'comments.lbl'=>'luba kommentaarid',
			'comments_mail.lbl'=>'saada kommentaarid e-postiga',
			'updated.lbl'=>'muudetud',
			'save.lbl'=>'salvesta',
			'read_more.lbl'=>'loe edasi',
			'prev.lbl'=>'eelmine',
			'next.lbl'=>'järgmine',
			'comments.form.title'=>'Kommentaarid',
			'comments.id.lbl'=>'ID',
			'comments.time.lbl'=>'aeg',
			'comments.name.lbl'=>'nimi',
			'comments.message.lbl'=>'kommentaar',
			'comments.captcha.lbl'=>'kontrollkood',
			'comments.post.lbl'=>'postita',
			'comments.user_ip.lbl'=>'IP',
			'comments.hostname.lbl'=>'domeen',
			'msg'=>'Kommentaar salvestatud!',
			'msg_value_required'=>'välja tämine on kohustuslik!',
			'msg_value_invalid'=>'sisestatud väärtus ei ole sobiv!',
			'msg_value_unique'=>'väärtus peab olema kordumatu!',
			'back.lbl'=>'tagasi',
			),
		);
	function __construct(&$axs_local) {
		global $axs;
		parent::__construct($axs_local);
		$this->sql_qry_banner[1]="(`arh`='0' OR `arh` IS NULL OR `arh`>'".$axs['time']."')";
		} #</__construct()>
	} #</class::axs_articles>
#2010-03-23 ?>